
#property copyright " 2008-2011 BJF Trading Group"
#property link      "wwwiticsoftwarecom"

#define major   3
#define minor   1

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Silver
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1



extern string _tmp1_ = " --- Common ---";
//Set 4, 5 or 0
//4: set 4 if your broker provides 4-digit quotes for EURUSD pair and 2-digit quotes for USDJPY pair
//5: set 5 if your broker provides 5-digit quotes for EURUSD pair and 3-digit quotes for USDJPY pair
//0: auto detect
extern int  AccDigits = 0;
extern bool UseOpenBar = false;


extern string _tmp2_ = " --- Spearman ---";
extern int  SpearRangeN = 7;


extern string _tmp3_ = " --- Divergence peaks ---";
extern int ChartLeftTopBarsL = 3;
extern int ChartLeftTopBarsR = 2;
extern int ChartRightTopBarsL = 2;
extern int ChartRightTopBarsR = 1;

extern int IndLeftTopBarsL = 2;
extern int IndLeftTopBarsR = 2;
extern int IndRightTopBarsL = 15;
extern int IndRightTopBarsR = 3;

extern int LeftTopsMaxBarsDiff = 10;
extern int RightTopsMaxBarsDiff = 5;


extern string _tmp4_ = " --- Levels ---";
extern double BullishDivResetAbove = 11;
extern double BearishDivResetBelow = -11;


extern string _tmp5_ = " --- Filters ---";
extern int MaxBars = 2000;
extern int DivWidthMinBars = 30;
extern int DivWidthMaxBars = 150;
extern int DivHeightMinPips = 1;
extern int DivHeightMaxPips = 1000;


extern string _tmp6_ = " --- Graphic ---";
extern color clBullishDiv = DeepSkyBlue;
extern color clBearishDiv = OrangeRed;

extern int ChartBullishDivArrowCode1 = 233;
extern int ChartBullishDivArrowCode2 = 32;
extern int ChartBearishDivArrowCode1 = 234;
extern int ChartBearishDivArrowCode2 = 32;

//M1;M5;M15;M30;H1;H4;D1;W1;MN1
extern string ChartArrowshift_all_TF = "5;5;10;10;15;20;70;200;300";
extern string ChartLineshift_all_TF = "0;0;0;0;0;0;0;0;0";

extern int ChartLinestyle = STYLE_DOT;
extern int ChartLinewidth = 1;
extern int IndLinestyle = STYLE_SOLID;
extern int IndLinewidth = 1;


extern string _tmp7_ = " --- Alerts ---";
extern bool   PopupOn  = true;
extern bool   MailOn   = false;
extern bool   SoundOn  = true;
extern string BullishDivSound = "alertwav";
extern string BearishDivSound = "alertwav";


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double ExtMapBuffer1[];
double R2[];
double multiply;
int    PriceInt[];
int    SortInt[];

double chart_right_fr[], chart_left_fr[];
double ind_right_fr[], ind_left_fr[];

int Chart_Arrow_shift[];
int Chart_Line_shift[];

string prefix;
string short_name;
datetime LastSigTime = 0;

double kIT = 0236;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

void init() 
{
  IndicatorBuffers(5);
    
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, ExtMapBuffer1);
   ArrayResize(R2, SpearRangeN);
   ArrayResize(PriceInt, SpearRangeN );
   ArrayResize(SortInt, SpearRangeN );

   multiply = MathPow(10, Digits);
   
    
  SetIndexBuffer(1, chart_right_fr);
  SetIndexBuffer(2, chart_left_fr);
  SetIndexBuffer(3, ind_right_fr);
  SetIndexBuffer(4, ind_left_fr);

  
  SetIndexEmptyValue(1, 00); 
  SetIndexEmptyValue(2, 00);
  SetIndexEmptyValue(3, 00);
  SetIndexEmptyValue(4, 00);

  short_name = "BJF Spearman Div("+SpearRangeN +")";
  IndicatorShortName(short_name);

  IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 1);
  
  SetLevelValue(0, BullishDivResetAbove);
  SetLevelValue(1, BearishDivResetBelow);
  
  
  prefix = WindowExpertName();  
  clear();
  
  split_i(Chart_Arrow_shift, ChartArrowshift_all_TF, ";");
  split_i(Chart_Line_shift, ChartLineshift_all_TF, ";");
}

void deinit()
{
  clear();
}

double fInd(int ind)
{
  return (ExtMapBuffer1[ind]);
}

double PointEx()
{
  if (AccDigits == 0)
  {
    if (Digits == 2 || Digits == 4) return (Point);
    if (Digits == 3 || Digits == 5) return (100*Point);

    return (Point);
  }
  
  if (AccDigits == 4)
  {
    return (Point);
  }

  if (AccDigits == 5)
  {
    return (100*Point);
  }
  
  return (Point);
}

void start() 
{  
  Spearman();
  
  int win_ind = WindowFind(short_name);
  if (win_ind == -1) win_ind = 1;

  //-----
  
  int counted_bars = IndicatorCounted();
  if (counted_bars > 0) counted_bars--;
  int limit = Bars-counted_bars;
  if (limit > 1) clear();
  
  //-----
  
  int i, j, k;
  double w;
  string obj_name;

  int chart_fri, ind_fri;
  int chart_frj, ind_frj;
    
  datetime time1, time2;
  double price1, price2;
  
  int x1, x2;
  double y1, y2, a, b, f;

  int shift = 0;
  if (!UseOpenBar)
  {
    shift = 1;
  }
  
  
  clear();
  
  for (i=0; i < Bars; i++)
  {
    chart_right_fr[i] = 00;
    chart_left_fr[i] = 00;
    
    ind_right_fr[i] = 00;
    ind_left_fr[i] = 00;
  }
  
  //-----
  
  limit = MaxBars;  
  for (i=0; i < limit; i++)
  {
    chart_right_fr[i] = chart_is_fr(MODE_UPPER, ChartRightTopBarsL, ChartRightTopBarsR, i);
    chart_left_fr[i] = chart_is_fr(MODE_UPPER, ChartLeftTopBarsL, ChartLeftTopBarsR, i);
    
    ind_right_fr[i] = ind_is_fr(MODE_UPPER, IndRightTopBarsL, IndRightTopBarsR, i);
    ind_left_fr[i] = ind_is_fr(MODE_UPPER, IndLeftTopBarsL, IndLeftTopBarsR, i);
  }
  
  //-----
  
  for (i=0; i < limit; i++)
  {
    chart_fri = i + ChartRightTopBarsR + shift;
    ind_fri = i + IndRightTopBarsR + shift;
    
    if (chart_right_fr[chart_fri] == 0 && ind_right_fr[ind_fri] == 0) continue;

    for (k=0; k < RightTopsMaxBarsDiff; k++)
    {
      if (chart_right_fr[chart_fri] != 0)
      {
        ind_fri = chart_fri + k;
        if (ind_right_fr[ind_fri] != 0 && ind_fri - IndRightTopBarsR - shift >= i)
        {
          break;
        }
      }

      if (ind_right_fr[ind_fri] != 0)
      {
        chart_fri = ind_fri + k;
        if (chart_right_fr[chart_fri] != 0 && chart_fri - ChartRightTopBarsR - shift >= i)
        {
          break;
        }
      }
    }
    
    if (chart_right_fr[chart_fri] == 0 || ind_right_fr[ind_fri] == 0) continue;
    
    //-----
    
    int j0 = MathMax(chart_fri, ind_fri) + 1;
    for (j=j0; j < limit; j++)
    {
      chart_frj = j;
      ind_frj = j;
     
      if (chart_frj - ChartLeftTopBarsR - shift < i + 1) continue;
      if (ind_frj - IndLeftTopBarsR - shift < i + 1) continue;


      if (chart_left_fr[chart_frj] == 0 && ind_left_fr[ind_frj] == 0) continue;

    
      for (k=0; k < LeftTopsMaxBarsDiff; k++)
      {
        if (chart_left_fr[chart_frj] != 0)
        {
          ind_frj = chart_frj + k;
          if (ind_left_fr[ind_frj] != 0 && ind_frj - IndLeftTopBarsR - shift >= i + 1)
          {
            break;
          }
        }

        if (ind_left_fr[ind_frj] != 0)
        {
          chart_frj = ind_frj + k;
          if (chart_left_fr[chart_frj] != 0 && chart_frj - ChartLeftTopBarsR - shift >= i + 1)
          {
            break;
          }
        }
      }


      if (chart_frj-chart_fri > DivWidthMaxBars) break;
      
      if (chart_left_fr[chart_frj] == 0 || ind_left_fr[ind_frj] == 0) continue;

      
      //-----
      
      if (chart_left_fr[chart_frj] > chart_right_fr[chart_fri]) break;

      if (ind_left_fr[ind_frj] < ind_right_fr[ind_fri]) continue;

      
      if (chart_frj-chart_fri < DivWidthMinBars) continue;
      if (ind_frj-ind_fri < DivWidthMinBars) continue;

      w = MathAbs(chart_left_fr[chart_frj] - chart_right_fr[chart_fri]);
      
      if (w < DivHeightMinPips*PointEx()) continue; 
      if (w > DivHeightMaxPips*PointEx()) continue;
      
      //-----

      int chartbar = -1;
      for (k = chart_fri+1; k < chart_frj; k++)
      {
        if (High[k] > High[chart_fri] + 1*PointEx())
        {
          chartbar = k;
          break;
        }
      }
      
      if (chartbar >= 0) break;
      
      //-----
      
      
      x1 = ind_frj;
      y1 = fInd(x1);
      x2 = ind_fri;
      y2 = fInd(x2);
      a = (y2-y1)/(x2-x1);
      b = y1 - a*x1;
      
      int indbar = -1;
      for (k = ind_fri; k < ind_frj; k++)
      {
        double indval = fInd(k);
        if (indval > ind_left_fr[ind_frj])
        {
          indbar = k;
          break;
        }


        f = a*k + b;
        if (fInd(k) > f + kIT*MathAbs(y2-y1))
        {
          indbar = k;
          break;
        }


        if (indval < BearishDivResetBelow)
        {
          indbar = k;
          break;
        }
      }
      
      if (indbar >= 0) break;
      
            
      //-----
            
      obj_name = prefix + "_chart_ua1_" + Time[i];
      time1 = Time[i];
      price1 = High[i] + 13*Chart_Arrow_shift[ITF(Period())]*PointEx();
      
      if (ObjectFind(obj_name) == -1)
      {
        ObjectCreate(obj_name, OBJ_ARROW, 0, time1, price1);
      }
      else
      {
        ObjectMove(obj_name, 0, time1, price1);
      }
      
      ObjectSet(obj_name, OBJPROP_WIDTH, 1);
      ObjectSet(obj_name, OBJPROP_COLOR, clBearishDiv);
      ObjectSet(obj_name, OBJPROP_ARROWCODE, ChartBearishDivArrowCode1);

      //-----
      
      obj_name = prefix + "_chart_ua2_" + Time[chart_frj];
      time1 = Time[chart_frj];
      price1 = High[chart_frj] + 13*Chart_Arrow_shift[ITF(Period())]*PointEx();
      
      if (ObjectFind(obj_name) == -1)
      {
        ObjectCreate(obj_name, OBJ_ARROW, 0, time1, price1);
      }
      else
      {
        ObjectMove(obj_name, 0, time1, price1);
      }
      
      ObjectSet(obj_name, OBJPROP_WIDTH, 1);
      ObjectSet(obj_name, OBJPROP_COLOR, clBearishDiv);
      ObjectSet(obj_name, OBJPROP_ARROWCODE, ChartBearishDivArrowCode2);

      //-----
      
      obj_name = prefix + "_chart_ul_" + Time[chart_frj] + "_" + Time[chart_fri];
      time1 = Time[chart_frj];
      price1 = High[chart_frj] + Chart_Line_shift[ITF(Period())]*PointEx();
      time2 = Time[chart_fri];
      price2 = High[chart_fri] + Chart_Line_shift[ITF(Period())]*PointEx();
      
      if (ObjectFind(obj_name) == -1)
      {
        ObjectCreate(obj_name, OBJ_TREND, 0, time1, price1, time2, price2);
      }
      else
      {
        ObjectMove(obj_name, 0, time1, price1);
        ObjectMove(obj_name, 1, time2, price2);
      }
              
      ObjectSet(obj_name, OBJPROP_RAY, false);
      ObjectSet(obj_name, OBJPROP_COLOR, clBearishDiv);
      ObjectSet(obj_name, OBJPROP_STYLE, ChartLinestyle);
      ObjectSet(obj_name, OBJPROP_WIDTH, ChartLinewidth);

      //-----
      
      obj_name = prefix + "_ind_ul_" + Time[ind_frj] + "_" + Time[ind_fri];
      time1 = Time[ind_frj];
      price1 = ind_left_fr[ind_frj];
      time2 = Time[ind_fri];
      price2 = ind_right_fr[ind_fri];

      if (ObjectFind(obj_name) == -1)
      {
        ObjectCreate(obj_name, OBJ_TREND, win_ind, time1, price1, time2, price2);
      }
      else
      {
        ObjectMove(obj_name, 0, time1, price1);
        ObjectMove(obj_name, 1, time2, price2);
      }

      ObjectSet(obj_name, OBJPROP_RAY, false);
      ObjectSet(obj_name, OBJPROP_COLOR, clBearishDiv);
      ObjectSet(obj_name, OBJPROP_STYLE, IndLinestyle);
      ObjectSet(obj_name, OBJPROP_WIDTH, IndLinewidth);
    }
  }
 
  
  //-----
  
  
  for (i=0; i < Bars; i++)
  {  
    chart_right_fr[i] = 00;
    chart_left_fr[i] = 00;
    
    ind_right_fr[i] = 00;
    ind_left_fr[i] = 00;
  }

  limit = MaxBars;
  for (i=0; i < limit; i++)
  {
    chart_right_fr[i] = chart_is_fr(MODE_LOWER, ChartRightTopBarsL, ChartRightTopBarsR, i);
    chart_left_fr[i] = chart_is_fr(MODE_LOWER, ChartLeftTopBarsL, ChartLeftTopBarsR, i);
    
    ind_right_fr[i] = ind_is_fr(MODE_LOWER, IndRightTopBarsL, IndRightTopBarsR, i);
    ind_left_fr[i] = ind_is_fr(MODE_LOWER, IndLeftTopBarsL, IndLeftTopBarsR, i);
  }



  for (i=0; i < limit; i++)
  {
    chart_fri = i + ChartRightTopBarsR + shift;
    ind_fri = i + IndRightTopBarsR + shift;
    
    if (chart_right_fr[chart_fri] == 0 && ind_right_fr[ind_fri] == 0) continue;

    for (k=0; k < RightTopsMaxBarsDiff; k++)
    {
      if (chart_right_fr[chart_fri] != 0)
      {
        ind_fri = chart_fri + k;
        if (ind_right_fr[ind_fri] != 0 && ind_fri - IndRightTopBarsR - shift >= i)
        {
          break;
        }
      }

      if (ind_right_fr[ind_fri] != 0)
      {
        chart_fri = ind_fri + k;
        if (chart_right_fr[chart_fri] != 0 && chart_fri - ChartRightTopBarsR - shift >= i)
        {
          break;
        }
      }
    }
    
    if (chart_right_fr[chart_fri] == 0 || ind_right_fr[ind_fri] == 0) continue;
    
    //-----
    
    j0 = MathMax(chart_fri, ind_fri) + 1;
    for (j=j0; j < limit; j++)
    {
      chart_frj = j;
      ind_frj = j;
     
      if (chart_frj - ChartLeftTopBarsR - shift < i + 1) continue;
      if (ind_frj - IndLeftTopBarsR - shift < i + 1) continue;


      if (chart_left_fr[chart_frj] == 0 && ind_left_fr[ind_frj] == 0) continue;

    
      for (k=0; k < LeftTopsMaxBarsDiff; k++)
      {
        if (chart_left_fr[chart_frj] != 0)
        {
          ind_frj = chart_frj + k;
          if (ind_left_fr[ind_frj] != 0 && ind_frj - IndLeftTopBarsR - shift >= i + 1)
          {
            break;
          }
        }

        if (ind_left_fr[ind_frj] != 0)
        {
          chart_frj = ind_frj + k;
          if (chart_left_fr[chart_frj] != 0 && chart_frj - ChartLeftTopBarsR - shift >= i + 1)
          {
            break;
          }
        }
      }


      if (chart_frj-chart_fri > DivWidthMaxBars) break;
      
      if (chart_left_fr[chart_frj] == 0 || ind_left_fr[ind_frj] == 0) continue;

      
      //-----

      if (chart_left_fr[chart_frj] < chart_right_fr[chart_fri]) break;

      if (ind_left_fr[ind_frj] > ind_right_fr[ind_fri]) continue;

      
      if (chart_frj-chart_fri < DivWidthMinBars) continue;
      if (ind_frj-ind_fri < DivWidthMinBars) continue;

      w = MathAbs(chart_left_fr[chart_frj] - chart_right_fr[chart_fri]);
      
      if (w < DivHeightMinPips*PointEx()) continue; 
      if (w > DivHeightMaxPips*PointEx()) continue;
      
      //-----

      chartbar = -1;
      for (k = chart_fri+1; k < chart_frj; k++)
      {
        if (Low[k] < Low[chart_fri] - 1*PointEx())
        {
          chartbar = k;
          break;
        }
      }
      
      if (chartbar >= 0) break;

      
      //-----
      
      x1 = ind_frj;
      y1 = fInd(x1);
      x2 = ind_fri;
      y2 = fInd(x2);
      a = (y2-y1)/(x2-x1);
      b = y1 - a*x1;

      indbar = -1;
      for (k = ind_fri; k < ind_frj; k++)
      {
        indval = fInd(k);
        if (indval < ind_left_fr[ind_frj])
        {
          indbar = k;
          break;
        }
        
        
        f = a*k + b;
        if (fInd(k) < f - kIT*MathAbs(y2-y1))
        {
          indbar = k;
          break;
        }


        if (indval > BullishDivResetAbove)
        {
          indbar = k;
          break;
        }
      }
      
      if (indbar >= 0) break;
      
            
      //-----
            
      obj_name = prefix + "_chart_la1_" + Time[i];
      time1 = Time[i];
      price1 = Low[i] - 10*Chart_Arrow_shift[ITF(Period())]*PointEx();
      
      if (ObjectFind(obj_name) == -1)
      {
        ObjectCreate(obj_name, OBJ_ARROW, 0, time1, price1);
      }
      else
      {
        ObjectMove(obj_name, 0, time1, price1);
      }
      
      ObjectSet(obj_name, OBJPROP_WIDTH, 1);
      ObjectSet(obj_name, OBJPROP_COLOR, clBullishDiv);
      ObjectSet(obj_name, OBJPROP_ARROWCODE, ChartBullishDivArrowCode1);

      //-----
      
      obj_name = prefix + "_chart_la2_" + Time[chart_frj];
      time1 = Time[chart_frj];
      price1 = Low[chart_frj] - 10*Chart_Arrow_shift[ITF(Period())]*PointEx();
      
      if (ObjectFind(obj_name) == -1)
      {
        ObjectCreate(obj_name, OBJ_ARROW, 0, time1, price1);
      }
      else
      {
        ObjectMove(obj_name, 0, time1, price1);
      }
      
      ObjectSet(obj_name, OBJPROP_WIDTH, 1);
      ObjectSet(obj_name, OBJPROP_COLOR, clBullishDiv);
      ObjectSet(obj_name, OBJPROP_ARROWCODE, ChartBullishDivArrowCode2);

      //-----
      
      obj_name = prefix + "_chart_ll_" + Time[chart_frj] + "_" + Time[chart_fri];
      time1 = Time[chart_frj];
      price1 = Low[chart_frj] - Chart_Line_shift[ITF(Period())]*PointEx();
      time2 = Time[chart_fri];
      price2 = Low[chart_fri] - Chart_Line_shift[ITF(Period())]*PointEx();
      
      if (ObjectFind(obj_name) == -1)
      {
        ObjectCreate(obj_name, OBJ_TREND, 0, time1, price1, time2, price2);
      }
      else
      {
        ObjectMove(obj_name, 0, time1, price1);
        ObjectMove(obj_name, 1, time2, price2);
      }
              
      ObjectSet(obj_name, OBJPROP_RAY, false);
      ObjectSet(obj_name, OBJPROP_COLOR, clBullishDiv);
      ObjectSet(obj_name, OBJPROP_STYLE, ChartLinestyle);
      ObjectSet(obj_name, OBJPROP_WIDTH, ChartLinewidth);

      //-----
      
      obj_name = prefix + "_ind_ll_" + Time[ind_frj] + "_" + Time[ind_fri];
      time1 = Time[ind_frj];
      price1 = ind_left_fr[ind_frj];
      time2 = Time[ind_fri];
      price2 = ind_right_fr[ind_fri];

      if (ObjectFind(obj_name) == -1)
      {
        ObjectCreate(obj_name, OBJ_TREND, win_ind, time1, price1, time2, price2);
      }
      else
      {
        ObjectMove(obj_name, 0, time1, price1);
        ObjectMove(obj_name, 1, time2, price2);
      }

      ObjectSet(obj_name, OBJPROP_RAY, false);
      ObjectSet(obj_name, OBJPROP_COLOR, clBullishDiv);
      ObjectSet(obj_name, OBJPROP_STYLE, IndLinestyle);
      ObjectSet(obj_name, OBJPROP_WIDTH, IndLinewidth);
    }
  }
  
  //-----
  
  if (Time[1] != LastSigTime)
  {
    obj_name = prefix + "_chart_la1_" + Time[0];
    bool LongSig = (ObjectFind(obj_name) != -1);
    
    obj_name = prefix + "_chart_ua1_" + Time[0];
    bool ShortSig = (ObjectFind(obj_name) != -1);
    
    if (LongSig || ShortSig)
    {
      LastSigTime = Time[1];
    }
    
    //-----------------------
    // Sound Alert
    //-----------------------
    if (SoundOn)
    {            
      if (LongSig)
        PlaySound(BearishDivSound);
        
      if (ShortSig)
        PlaySound(BullishDivSound);
    }
   
    //-----------------------
    // Popup Alert
    //-----------------------
    string msg;
      
    if (PopupOn)
    {
      if (LongSig)
      {
        msg = WindowExpertName() + " " + Symbol() + " " + TF2Str(Period()) +
          ":  BEARISH divergence at " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS);
        
        Alert(msg);
      }
      
      if (ShortSig)
      {
        msg = WindowExpertName() + " " + Symbol() + " " + TF2Str(Period()) +
          ":  BULLISH divergence at " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS);
    
        Alert(msg);
      }
    }
   
    //-----------------------
    // Mail Alert
    //-----------------------
    if (MailOn)
    {
      if (LongSig)
      {
        msg = Symbol() + " " + TF2Str(Period()) +
          ":  BEARISH divergence at " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS);
  
        SendMail(WindowExpertName(), msg);
      }

      if (ShortSig)
      {
        msg = Symbol() + " " + TF2Str(Period()) +
          ":  BEARISH divergence at " + TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS);
          
        SendMail(WindowExpertName(), msg);
      }
    }
  } //if (LastSigTime != Time[1])
}  


int Spearman()
{
   int counted_bars = IndicatorCounted();
//----
   int i, k, limit;
   if(counted_bars == 0)
     limit = Bars - SpearRangeN ;
  
   if(counted_bars > 0)
       limit = Bars - counted_bars;
       
   for(i = limit; i >= 0; i--)
     {
       for(k = 0; k < SpearRangeN ; k++) 
           PriceInt[k] = Close[i+k]*multiply;
       RankPrices(PriceInt);
       ExtMapBuffer1[i] = SpearmanRankCorrelation(R2,SpearRangeN );
     }
//----
   return(0);
}

//+------------------------------------------------------------------+
//| calculate  RSP  function                                         |
//+------------------------------------------------------------------+
double SpearmanRankCorrelation(double Ranks[], int N)
  {
//----
   double res,z2;
   int i;
   for(i = 0; i < N; i++)
     {
       z2 += MathPow(Ranks[i] - i - 1, 2);
     }
   res = 1 - 6*z2 / (MathPow(N,3) - N);
//----
   return(res);
  }
//+------------------------------------------------------------------+
//| Ranking array of prices function                                 |
//+------------------------------------------------------------------+
void RankPrices(int InitialArray[])
  {
  
  //int SpearSortDir = MODE_DESCEND;
  int SpearSortDir = MODE_ASCEND;
  
//----
   int i, k, m, dublicat, counter, etalon;
   double dcounter, averageRank;
   double TrueRanks[];
   ArrayResize(TrueRanks, SpearRangeN);
   ArrayCopy(SortInt, InitialArray);
   for(i = 0; i < SpearRangeN; i++) 
       TrueRanks[i] = i + 1;

   ArraySort(SortInt, 0, 0, SpearSortDir);

   for(i = 0; i < SpearRangeN-1; i++)
     {
       if(SortInt[i] != SortInt[i+1]) 
           continue;
       dublicat = SortInt[i];
       k = i + 1;
       counter = 1;
       averageRank = i + 1;
       while(k < SpearRangeN)
         {
           if(SortInt[k] == dublicat)
             {
               counter++;
               averageRank += k + 1;
               k++;
             }
           else
               break;
         }
       dcounter = counter;
       averageRank = averageRank / dcounter;
       for(m = i; m < k; m++)
           TrueRanks[m] = averageRank;
       i = k;
     }
   for(i = 0; i < SpearRangeN; i++)
     {
       etalon = InitialArray[i];
       k = 0;
       while(k < SpearRangeN)
         {
           if(etalon == SortInt[k])
             {
               R2[i] = TrueRanks[k];
               break;
             }
           k++;
         }
     }
//----
   return;
}

void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
}


double chart_is_fr(int mode, int left_period, int right_period, int shift)
{
  int l = 0;
  int r = 0;

  if (mode == MODE_UPPER)
  {
    for (int i=1; i <= left_period; i++)
    {
      if (shift+i >= Bars) break;
      
      if (High[shift+i] <= High[shift]) l++;
    }

    for (i=1; i <= right_period; i++)
    {
      if (shift-i < 0) break;
      
      if (High[shift-i] < High[shift]) r++;
    }
    
    if (l == left_period && r == right_period) return (High[shift]);
  }


  if (mode == MODE_LOWER)
  {
    for (i=1; i <= left_period; i++)
    {
      if (shift+i >= Bars) break;
      
      if (Low[shift+i] >= Low[shift]) l++;
    }

    for (i=1; i <= right_period; i++)
    {
      if (shift-i < 0) break;
      
      if (Low[shift-i] > Low[shift]) r++;
    }
    
    if (l == left_period && r == right_period) return (Low[shift]);
  }
  
  return (0);
}


double ind_is_fr(int mode, int left_period, int right_period, int shift)
{
  int l = 0;
  int r = 0;
  
  double indval, indval_l, indval_r;
  
  indval = fInd(shift);

  if (mode == MODE_UPPER)
  {
    for (int i=1; i <= left_period; i++)
    {
      if (shift+i >= Bars) break;
          
      indval_l = fInd(shift+i);
      if (indval_l <= indval) l++;
    }

    for (i=1; i <= right_period; i++)
    {
      if (shift-i < 0) break;

      indval_r = fInd(shift-i);
      if (indval_r < indval) r++;
    }
    
    if (l == left_period && r == right_period) return (indval);
  }
  

  if (mode == MODE_LOWER)
  {
    for (i=1; i <= left_period; i++)
    {
      if (shift+i >= Bars) break;
      
      indval_l = fInd(shift+i);
      if (indval_l >= indval) l++;
    }

    for (i=1; i <= right_period; i++)
    {
      if (shift-i < 0) break;
      
      indval_r = fInd(shift-i);
      if (indval_r > indval) r++;
    }
    
    if (l == left_period && r == right_period) return (indval);
  }
  
  return (0);
}

void split_i(int& arr[], string str, string sym) 
{
  ArrayResize(arr, 0);
  string item;
  int pos, size;
  
  int len = StringLen(str);
  for (int i=0; i < len;) 
  {
    pos = StringFind(str, sym, i);
    if (pos == -1) pos = len;
    
    item = StringSubstr(str, i, pos-i);
    item = StringTrimLeft(item);
    item = StringTrimRight(item);
    
    size = ArraySize(arr);
    ArrayResize(arr, size+1);
    arr[size] = StrToInteger(item);
    
    i = pos+1;
  }
}

int ITF(int period)
{
  if (period == PERIOD_M1)  return (0);
  if (period == PERIOD_M5)  return (1);
  if (period == PERIOD_M15) return (2);
  if (period == PERIOD_M30) return (3);
  if (period == PERIOD_H1)  return (4);
  if (period == PERIOD_H4)  return (5);
  if (period == PERIOD_D1)  return (6);
  if (period == PERIOD_W1)  return (7);
  if (period == PERIOD_MN1) return (8);
  
  return (4);
}

string TF2Str(int period)
{
  switch (period) 
  {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("D1");
    case PERIOD_W1:  return("W1");
    case PERIOD_MN1: return("MN1");
 }
 
  return (Period());
}

